package sunw.beanbox;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.lang.reflect.Method;

class PropertyHookupTarget implements Serializable {
   static final long serialVersionUID = -8352305996623495352L;
   private static int ourVersion = 1;
   Object object;
   Method setter;

   PropertyHookupTarget(Object var1, Method var2) {
      this.object = var1;
      this.setter = var2;
   }

   private void writeObject(ObjectOutputStream var1) throws IOException {
      var1.writeInt(ourVersion);
      var1.writeObject(this.setter.toString());
      var1.writeObject(this.object);
   }

   private void readObject(ObjectInputStream var1) throws ClassNotFoundException, IOException {
      var1.readInt();
      String var2 = (String)var1.readObject();
      this.object = var1.readObject();
      this.setter = null;
      Method[] var3 = this.object.getClass().getMethods();

      for(int var4 = 0; var4 < var3.length; ++var4) {
         if (var3[var4].toString().equals(var2)) {
            this.setter = var3[var4];
            break;
         }
      }

      if (this.setter == null) {
         throw new IOException("PropertyHookupTarget : no suitable setter\n    " + var2 + "\n    in class " + this.object.getClass());
      }
   }
}
